"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var requireModule_1 = require("./requireModule");
var platform_1 = require("./platform");
var pkg = requireModule_1.default('./package.json');
var SPIN_CONFIG_NAME = '.spinrc';
var ConfigRc = (function () {
    function ConfigRc() {
        var config = fs.existsSync(SPIN_CONFIG_NAME) ?
            JSON.parse(fs.readFileSync(SPIN_CONFIG_NAME).toString()) : pkg.spin;
        var nodes = {};
        for (var _i = 0, _a = Object.keys(config.nodes); _i < _a.length; _i++) {
            var name = _a[_i];
            var nodeVal = config.nodes[name];
            var node = typeof nodeVal === 'object' ? __assign({}, nodeVal) : { features: nodeVal };
            node.name = name;
            node.platform = new platform_1.default(config.options.features, typeof node === 'object' ? node.features : node);
            node.roles = node.roles || ['build', 'watch'];
            nodes[node.name] = node;
        }
        this.nodes = nodes;
        this.options = __assign({}, config.options);
        var options = this.options;
        options.backendBuildDir = options.backendBuildDir || 'build/server';
        options.frontendBuildDir = options.frontendBuildDir || 'build/client';
        options.dllBuildDir = options.dllBuildDir || 'build/dll';
        options.webpackDevPort = options.webpackDevPort || 3000;
        options.webpackDll = options.webpackDll !== undefined ? options.webpackDll : true;
    }
    return ConfigRc;
}());
exports.default = ConfigRc;
//# sourceMappingURL=configRc.js.map