"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var merge = require("webpack-merge");
var configRc_1 = require("./configRc");
var generator_1 = require("./generator");
var platform_1 = require("./platform");
var requireModule_1 = require("./requireModule");
var WEBPACK_OVERRIDES_NAME = 'webpack.overrides.js';
var createConfig = function (cmd) {
    var nodes = {};
    var config = new configRc_1.default();
    var options = config.options;
    try {
        for (var name in config.nodes) {
            var node = config.nodes[name];
            var platform = node.platform;
            var dev = cmd === 'watch' || cmd === 'test';
            if (node.roles.indexOf(cmd) < 0)
                continue;
            var overrides = void 0;
            var overridesConfig = options.overridesConfig || WEBPACK_OVERRIDES_NAME;
            if (fs.existsSync(overridesConfig)) {
                overrides = requireModule_1.default('./' + overridesConfig);
            }
            else {
                overrides = {};
            }
            nodes[name] = __assign({}, node, { config: generator_1.default(node, config.nodes, dev, options) });
            if (overrides[name]) {
                nodes[name].config = merge(nodes[name].config, overrides[name]);
            }
            if (options.webpackDll && !platform.hasAny('server')) {
                var dllNode = __assign({}, node);
                var dllNodeName = node.name + 'Dll';
                dllNode.parentName = node.name;
                dllNode.name = dllNodeName;
                dllNode.platform = new platform_1.default(dllNode.platform.features, 'dll');
                nodes[name].dllConfig = generator_1.default(dllNode, config.nodes, dev, options, overrides.dependencyPlatforms || {});
                if (overrides[dllNodeName]) {
                    nodes[name].dllConfig = merge(nodes[name].dllConfig, overrides[dllNodeName]);
                }
            }
        }
    }
    catch (e) {
        console.error(e.stack);
    }
    return { nodes: nodes, options: options };
};
exports.default = createConfig;
//# sourceMappingURL=spin.config.js.map